import java.util.*;

public class Arraz {

    public int sumValuesOfArray(int[] intArr){
        int sum = 0;
        for (int i:intArr) {
            sum += i;
        }
        return sum;
    }

    public double sumDoublesOfArray(double[] doublesArr){
        double sum = 0;
        for (double i:doublesArr) {
            sum += i;
        }
        return sum;
    }

    public int averageOfArray(int[] intArr){
        int sum = sumValuesOfArray(intArr);
        return sum / intArr.length;
    }

    public double doubleAverageOfArray(double[] doublesArr){
        double sum = sumDoublesOfArray(doublesArr);
        return sum / doublesArr.length;
    }

    public boolean containsValue(int[] intsArr, int findThisInt){
        boolean retBoolean = false;
        for (int i:intsArr) {
            if (i == findThisInt){
                retBoolean = true;
                break;
            }
        }
        return retBoolean;
    }

    public int[] reverseArray(int[] intsArr){
        int[] retArr = new int[intsArr.length];
        int counter = intsArr.length - 1;

        for (int i:intsArr) {
            retArr[counter] = i;
            counter--;
        }

        return retArr;
    }

    public OddEven getOddEvensOfArray(int[] intsArr){
        OddEven oddEven = new OddEven();
        oddEven.evens = 0;
        oddEven.odds = 0;

        for (int i:intsArr) {
            if(i % 2 == 0){
                oddEven.evens++;
            } else {
                oddEven.odds++;
            }
        }
        return oddEven;
    }

    public int findIndexOf(int[] intsArr, int index){
        return intsArr[index];
    }


    public int[] copyArrayByIterator(Integer[] intInput) {
        int[] retArr = new int[intInput.length];
        List<Integer> list = Arrays.asList(intInput);
        Iterable<Integer> iterable = list;
        Iterator<Integer> iterator = iterable.iterator();

        int index = 0;
        while (index < intInput.length){
            retArr[index] = iterator.next();
            index++;
        }

        return retArr;
    }

    public int[] copyArrayByLoop(int[] ints){
        int[] retArr = new int[ints.length];
        for (int i = 0; i < ints.length; i++) {
            retArr[i] = ints[i];
        }
        return retArr;
    }

    public int[] removeElementFromArray(int[] ints, int removeInt){
        int[] retArr = new int[ints.length - 1];

        int index = 0;
        for (int i:ints) {
            if (i != removeInt){
                retArr[index] = i;
                index++;
            }
        }
        return retArr;
    }

    public int[] insertIntoArrayAt(int[] ints, int index, int intToInsert){
        int[] retArr = new int[ints.length + 1];

        int intsIndex = 0;
        for (int i = 0; i < retArr.length; i++){
            if (i == index){
                retArr[i] = intToInsert;
            }
            else {
                retArr[i] = ints[intsIndex];
                intsIndex++;
            }
        }
        return retArr;
    }

    public MaxMin findMaxMinOfArray(int[] ints){
        MaxMin maxMin = new MaxMin();
        int minVal = Integer.MAX_VALUE;
        int maxVal = Integer.MIN_VALUE;

        for (int i:ints) {
            if (i < minVal){
                minVal = i;
            }
            if (i > maxVal){
                maxVal = i;
            }
        }

        maxMin.min = minVal;
        maxMin.max = maxVal;
        return maxMin;
    }

    public int[] removeDupesFromArray(int[] ints){
        ArrayList<Integer> retArr = new ArrayList();
        retArr.add(ints[0]);

        for (int i = 1; i < ints.length; i++) {
            if (!retArr.contains(ints[i])){
                retArr.add(ints[i]);
            }
        }
        int[] intsToRet = new int[retArr.size()];

        int counter = 0;
        for (int i:retArr) {
            intsToRet[counter] = i;
            counter++;
        }
        return intsToRet;
    }

    public double find2ndLargestValueFromArray(double[] dArr){
        double max = Double.MIN_VALUE;
        double secondMax = Double.MIN_VALUE;

        for (double d:dArr) {
            if (d > max){
                max = d;
            }
        }

        for (double d:dArr) {
            if (d < max && d > secondMax){
                secondMax = d;
            }
        }
        return secondMax;
    }

    public ArrayList<Integer> makeMeAnArrayListFromArray(int[] intsArr){
        ArrayList<Integer> retArr = new ArrayList<>();
        for (int i: intsArr) {
            retArr.add(i);
        }
        return retArr;
    }

    public int[] makeMeAnArrayFromArrayList(ArrayList<Integer> intArr){
        int[] retArr = new int[intArr.size()];

        int index = 0;
        for (int i:intArr) {
            retArr[index] = i;
            index++;
        }

        return retArr;
    }

    public boolean check2ArraysForEqual(int[] a, int[] b){
        if (a.length != b.length){
            return false;
        } else {
            for (int i = 0; i < a.length; i++) {
                if (a[i] != b[i]){
                    return false;
                }
            }
        }
        return true;
    }

    public double averageArrayWithoutMaxMin(int[] arr){
        MaxMin maxMin = findMaxMinOfArray(arr);
        double sum;
        boolean haveMax = false;
        boolean haveMin = false;

        ArrayList<Integer> arrayList = new ArrayList<Integer>();

        for (int i: arr) {
            if (i == maxMin.max && haveMax == false ){
                haveMax = true;
            }
            else if (i == maxMin.min && haveMin == false){
                haveMin = true;
            }
            else {
                arrayList.add(i);
            }
        }
        sum = arrayList.stream()
                .mapToDouble(Integer::doubleValue)
                .sum();

        return sum / arrayList.size();
    }

    public boolean arrayHas65and77(int[] arr){
        boolean has65 = false;
        boolean has77 = false;

        for (int i:arr) {
            if (i == 65){
                has65 = true;
            }
            if (i == 77){
                has77 = true;
            }
        }
        return has65 && has77;
    }

    public boolean theTotalofTensIs30(int[] arr) {
        int sum = 0;

        for (int i:arr) {
            if (i == 10){
                sum += i;
            }
        }
        return sum == 30;
    }

    public int[] findSmallestAnd2ndSmallest(int[] arr){
        int minValue = Integer.MAX_VALUE;

        for (int d:arr) {
            if (d < minValue){
                minValue = d;
            }
        }

        int secondMin = find2ndSmallestValueFromArray(arr, minValue);
        int[] retArr = {minValue, secondMin};

        return retArr;
    }

    private int find2ndSmallestValueFromArray(int[] arr, int minValue){
        int secondMin = Integer.MAX_VALUE;

        for (int d:arr) {
            if (d > minValue && d < secondMin){
                secondMin = d;
            }
        }
        return secondMin;
    }

    public int[] makeMeACopyPlease(int[] arr) {
        int[] retArr = new int[arr.length];

        int index = 0;
        for (int i = arr.length - 1; i >= 0 ; i--) {
            retArr[index] = arr[i];
            index++;
        }
        return retArr;
    }

    public int[] removeLastItemAndCopy(int[] arr) {
        int[] retArr = new int[arr.length - 1];

        for (int i = 0; i < retArr.length; i++) {
            retArr[i] = arr[i];
        }
        return retArr;
    }

    public int[] removeFirstItemAndCopy(int[] arr) {
        int[] retArr = new int[arr.length - 1];

        for (int i = 1; i < arr.length; i++) {
            retArr[i-1] = arr[i];
        }
        return retArr;
    }

    public int[] insertAtStartAndCopy(int[] arr, int insert) {
        int[] retArr = new int[arr.length + 1];
        retArr[0] = insert;

        for (int i = 0; i < arr.length; i++) {
            retArr[i+1] = arr[i];
        }
        return retArr;
    }

    public int[] insertAtEndAndCopy(int[] arr, int insert) {
        int[] retArr = new int[arr.length + 1];
        retArr[retArr.length - 1] = insert;

        for (int i = 0; i < arr.length; i++) {
            retArr[i] = arr[i];
        }
        return retArr;
    }

    public int[] sortArrayIntoEvensThenOdds(int[] arr) {
        ArrayList<Integer> evenList = new ArrayList<>();
        ArrayList<Integer> oddList = new ArrayList<>();
        int retArrLength = arr.length;

        for (int i: arr) {
            if (i % 2 == 0){
                evenList.add(i);
            }
            else {
                oddList.add(i);
            }
        }

        return retArr(evenList, oddList, retArrLength);
    }

    private int[] retArr(ArrayList<Integer> even, ArrayList<Integer> odd, int retArrLength){
        int[] retArr = new int[retArrLength];

        int index = 0;
        for (int i: even) {
            retArr[index] = i;
            index++;
        }

        for (int i: odd) {
            retArr[index] = i;
            index++;
        }
        return retArr;
    }
}
