import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.*;

public class ArrazTest {
    Arraz arraz = new Arraz();

    @Before
    public void setUp(){

    }

    @Test
    public void test1sumValuesOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 15;
        int actual = arraz.sumValuesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2sumValuesOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 100};

        //WHEN
        int expected = 115;
        int actual = arraz.sumValuesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1sumDoublesOfArray(){
        //GIVEN
        double[] arr = {1, 2, 3, 4, 5.5};

        //WHEN
        double expected = 15.5;
        double actual = arraz.sumDoublesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2sumDoublesOfArray(){
        //GIVEN
        double[] arr = {1.999, 2, 3, 4, 5, 100};

        //WHEN
        double expected = 115.999;
        double actual = arraz.sumDoublesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1averageOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 3;
        int actual = arraz.averageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2averageOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 6};

        //WHEN
        int expected = 3;
        int actual = arraz.averageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1doubleAverageOfArray(){
        //GIVEN
        double[] arr = {.75, 2, 3, 4, 5.25};

        //WHEN
        double expected = 3;
        double actual = arraz.doubleAverageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2doubleAverageOfArray(){
        //GIVEN
        double[] arr = {.001, 2, 3.141, 4, 5, 6.999};

        //WHEN
        double expected = 3.5235;
        double actual = arraz.doubleAverageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1containsValue(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int test = 3;
        boolean expected = true;
        boolean actual = arraz.containsValue(arr, test);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2containsValue(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 6};

        //WHEN
        int test = 7;
        boolean expected = false;
        boolean actual = arraz.containsValue(arr, test);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1reverseArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int[] expected = {5, 4, 3, 2, 1};
        int[] actual = arraz.reverseArray(arr);

        //THEN
        Assert.assertEquals(arr[1], actual[3]);
    }

    @Test
    public void test2reverseArray(){
        //GIVEN
        int[] arr = {-2, -1, 0, 1};

        //WHEN
        int[] expected = {1, 0, -1, -2};
        int[] actual = arraz.reverseArray(arr);

        //THEN
        Assert.assertEquals(arr[0], actual[3]);
    }

    @Test
    public void test1getOddEvensOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 2;
        int actual = arraz.getOddEvensOfArray(arr).evens;

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2getOddEvensOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 3;
        int actual = arraz.getOddEvensOfArray(arr).odds;

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1findIndexOf() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int index = 4;
        //WHEN
        int expected = 5;
        int actual = arraz.findIndexOf(arr, index);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2findIndexOf() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int index = 1;
        //WHEN
        int expected = 2;
        int actual = arraz.findIndexOf(arr, index);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1copyArrayByIterator() {
        //GIVEN
        Integer[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] retArr = arraz.copyArrayByIterator(arr);
        int expected = 3;

        //THEN
        int actual = retArr[2];
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2copyArrayByIterator() {
        //GIVEN
        Integer[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] retArr = arraz.copyArrayByIterator(arr);
        int expected = 5;

        //THEN
        int actual = retArr[4];
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1copyArrayByLoop() {
        //GIVEN
        int[] expected = {1, 2, 3, 4, 5};
        //WHEN
        int[] actual = arraz.copyArrayByLoop(expected);

        //THEN
        Assert.assertEquals(expected[0], actual[0]);
    }

    @Test
    public void test2copyArrayByLoop() {
        //GIVEN
        int[] expected = {1, 2, 3, 4, 5};
        //WHEN
        int[] actual = arraz.copyArrayByLoop(expected);

        //THEN
        Assert.assertEquals(expected[expected.length - 1], actual[expected.length - 1]);
    }

    @Test
    public void test1removeElementFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int removeInt = 5;
        //WHEN
        int expected = 4;
        int actual = arraz.removeElementFromArray(arr, removeInt).length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2removeElementFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int removeInt = 1;
        //WHEN
        int expected = 2;
        int[] actual = arraz.removeElementFromArray(arr, removeInt);
        //THEN
        Assert.assertEquals(expected, actual[0]);
    }

    @Test
    public void test1insertIntoArrayAt() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int addInt = 6;
        int atIndex = 3;
        //WHEN
        int expected = 6;
        int[] retArr = arraz.insertIntoArrayAt(arr, atIndex, addInt);
        int actual = retArr[atIndex];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2insertIntoArrayAt() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int addInt = 6;
        int atIndex = 5;
        //WHEN
        int expected = 6;
        int[] retArr = arraz.insertIntoArrayAt(arr, atIndex, addInt);
        int actual = retArr[atIndex];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1findMaxMinOfArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int expectedMax = 5;
        int expectedMin = 1;
        MaxMin maxMin = arraz.findMaxMinOfArray(arr);

        int actualMax = maxMin.max;
        int actualMin = maxMin.min;
        //THEN
        Assert.assertEquals(expectedMax, actualMax);
        Assert.assertEquals(expectedMin, actualMin);
    }

    @Test
    public void test2findMaxMinOfArray() {
        //GIVEN
        int[] arr = {1, -2, 300, 4, 5};
        //WHEN
        int expectedMax = 300;
        int expectedMin = -2;
        MaxMin maxMin = arraz.findMaxMinOfArray(arr);

        int actualMax = maxMin.max;
        int actualMin = maxMin.min;
        //THEN
        Assert.assertEquals(expectedMax, actualMax);
        Assert.assertEquals(expectedMin, actualMin);
    }

    @Test
    public void test1removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3};
        //WHEN
        int expectedLength = 5;

        int actualLength = arraz.removeDupesFromArray(arr).length;
        //THEN
        Assert.assertEquals(expectedLength, actualLength);
    }

    @Test
    public void test2removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3, 1, 1, 1, 2, 3, 4, 5};
        //WHEN
        int expectedLength = 5;

        int actualLength = arraz.removeDupesFromArray(arr).length;
        //THEN
        Assert.assertEquals(expectedLength, actualLength);
    }

    @Test
    public void test3removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3, 1, 1, 1, 2, 3, 4, 5, 6};
        //WHEN
        int expected = 6;

        int[] actualArray = arraz.removeDupesFromArray(arr);
        int actual = actualArray[5];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1find2ndLargestValueFromArray() {
        //GIVEN
        double[] arr = {10, 20.2, 30.3, 40.4, 50};
        //WHEN
        double expected = 40.4;

        double actual = arraz.find2ndLargestValueFromArray(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2find2ndLargestValueFromArray() {
        //GIVEN
        double[] arr = {40.5, 500, 10, 20.2, 30.3, 40.4};
        //WHEN
        double expected = 40.5;

        double actual = arraz.find2ndLargestValueFromArray(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1makeMeAnArrayListFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3};
        //WHEN
        int expected = 5;

        int actual = arraz.makeMeAnArrayListFromArray(arr).get(4);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2makeMeAnArrayListFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3, 1, 1, 1, 2, 3, 4, 5};
        //WHEN
        int expected = 13;

        int actual = arraz.makeMeAnArrayListFromArray(arr).size();
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1makeMeAnArrayFromArrayList() {
        //GIVEN
        ArrayList<Integer> arr = new ArrayList<Integer>();
        arr.add(1); arr.add(2); arr.add(3);
        //WHEN
        int expected = 1;

        int[] actualArr = arraz.makeMeAnArrayFromArrayList(arr);
        int actual = actualArr[0];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2makeMeAnArrayFromArrayList() {
        //GIVEN
        ArrayList<Integer> arr = new ArrayList<Integer>();
                arr.add(1); arr.add(2); arr.add(3);
        //WHEN
        Class expected = Integer.TYPE;

        Class actual = arraz.makeMeAnArrayFromArrayList(arr).getClass().getComponentType();
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1check2ArraysForEqual() {
        //GIVEN
        int[] a = {1, 2, 3, 4, 5, 3};
        int[] b = {1, 2, 3, 4, 5, 3};
        //WHEN
        boolean expected = true;

        boolean actual = arraz.check2ArraysForEqual(a, b);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2check2ArraysForEqual() {
        int[] a = {1, 2, 3, 4, 5, 3};
        int[] b = {1, 2, 3, 4, 5, 3, 1};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.check2ArraysForEqual(a, b);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test3check2ArraysForEqual() {
        int[] a = {1, 2, 3, 4, 5, 3};
        int[] b = {1, 2, 2, 4, 5, 3};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.check2ArraysForEqual(a, b);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1averageArrayWithoutMaxMin() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        double expected = 3;

        double actual = arraz.averageArrayWithoutMaxMin(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2averageArrayWithoutMaxMin() {
        //GIVEN
        int[] arr = {1, 4, 3, 4, 5, 5};
        //WHEN
        double expected = 4;

        double actual = arraz.averageArrayWithoutMaxMin(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1arrayHas65and77() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.arrayHas65and77(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2arrayHas65and77() {
        //GIVEN
        int[] arr = {1, 2, 3, 65, 5};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.arrayHas65and77(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test3arrayHas65and77() {
        //GIVEN
        int[] arr = {1, 2, 3, 77, 5};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.arrayHas65and77(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void test4arrayHas65and77() {
        //GIVEN
        int[] arr = {1, 2, 3, 77, 65};
        //WHEN
        boolean expected = true;

        boolean actual = arraz.arrayHas65and77(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testTheTotalofTensIs30(){
        //GIVEN
        int[] arr = {10, 2, 10, 77, 10};
        //WHEN
        boolean expected = true;

        boolean actual = arraz.theTotalofTensIs30(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2TheTotalofTensIs30(){
        //GIVEN
        int[] arr = {10, 2, 0, 77, 10};
        //WHEN
        boolean expected = false;

        boolean actual = arraz.theTotalofTensIs30(arr);
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1FindSmallestAnd2ndSmallest() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int expectedSmallest = 1;
        int expected2ndSmallest = 2;

        int[] retArr = arraz.findSmallestAnd2ndSmallest(arr);
        int actualSmallest = retArr[0];
        int actual2ndSmallest = retArr[1];
        //THEN
        Assert.assertEquals(expectedSmallest, actualSmallest);
        Assert.assertEquals(expected2ndSmallest, actual2ndSmallest);
    }

    @Test
    public void test2FindSmallestAnd2ndSmallest() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, -3, -1000, 13, 13, 44444};
        //WHEN
        int expectedSmallest = -1000;
        int expected2ndSmallest = -3;

        int[] retArr = arraz.findSmallestAnd2ndSmallest(arr);
        int actualSmallest = retArr[0];
        int actual2ndSmallest = retArr[1];
        //THEN
        Assert.assertEquals(expectedSmallest, actualSmallest);
        Assert.assertEquals(expected2ndSmallest, actual2ndSmallest);
    }

    @Test
    public void test1makeMeACopyPlease() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] actual = arraz.makeMeACopyPlease(arr);

        //THEN
        Assert.assertEquals(arr[0], actual[4]);
    }

    @Test
    public void test2makeMeACopyPlease() {
        //GIVEN
        int[] arr = {4, 6, 2, 8};
        //WHEN
        int[] actual = arraz.makeMeACopyPlease(arr);

        //THEN
        Assert.assertEquals(arr[1], actual[2]);
    }

    @Test
    public void test1removeLastItemAndCopy() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] retArr = arraz.removeLastItemAndCopy(arr);
        int expected = 4;
        int actual = retArr.length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2removeLastItemAndCopy() {
        //GIVEN
        int[] arr = {4, 6, 2, 8};
        //WHEN
        int[] actual = arraz.removeLastItemAndCopy(arr);

        //THEN
        Assert.assertEquals(arr[2], actual[actual.length - 1]);
    }

    @Test
    public void test1removeFirstItemAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] retArr = arraz.removeFirstItemAndCopy(arr);
        int expected = 4;
        int actual = retArr.length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2removeFirstItemAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int[] retArr = arraz.removeFirstItemAndCopy(arr);
        int expected = 2;
        int actual = retArr[0];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1insertAtStartAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int insert = 777;
        //WHEN
        int[] retArr = arraz.insertAtStartAndCopy(arr, insert);
        int expected = 6;
        int actual = retArr.length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2insertAtStartAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int insert = 777;
        //WHEN
        int[] retArr = arraz.insertAtStartAndCopy(arr, insert);
        int expected = 777;
        int actual = retArr[0];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1insertAtEndAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int insert = 777;
        //WHEN
        int[] retArr = arraz.insertAtEndAndCopy(arr, insert);
        int expected = 777;
        int actual = retArr[retArr.length - 1];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2insertAtEndAndCopy(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int insert = 777;
        //WHEN
        int[] retArr = arraz.insertAtEndAndCopy(arr, insert);
        int expected = 6;
        int actual = retArr.length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1sortArrayIntoEvensThenOdds(){
        //GIVEN
        int[] arr = {4,5,102,6,-7,12,-32,92,8};
        //WHEN
        int[] retArr = arraz.sortArrayIntoEvensThenOdds(arr);
        int expected = 4;
        int actual = retArr[0];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2sortArrayIntoEvensThenOdds(){
        //GIVEN
        int[] arr = {4,5,102,6,-7,12,-32,92,8};
        //WHEN
        int[] retArr = arraz.sortArrayIntoEvensThenOdds(arr);
        int expected = -7;
        int actual = retArr[retArr.length - 1];
        //THEN
        Assert.assertEquals(expected, actual);
    }
}